#! /bin/bash
usage ()
{
    echo "cxc_patch.sh [-s | -b] -f <file of patches"
    echo "             -r <path of distrbutrion>"
    echo "             -v <path of patchs>"
    echo "Where"
    echo "  -s - Only install Source code."
    echo "  -b - Install Source code and new binaries."
    echo "       (Default is to install binaries only)"
#    echo "  -nh - Do not hide uninstall files
    echo "  -f <file of patches> Files list supplied with"
    echo "       this distribution. Default: $ListFiles"
    echo "  -r <path of distriburtion> Directory to install"
    echo "       patches to. Default is $RootTree"
    echo "  -v <path of patches> Directory where patches were"
    echo "       untarred to. Default is $FromTree"
    echo "  -u <oldVersion> Uninstall current version to"
    echo "      oldversion."
#    echo "  -p build patch package"
#    echo "  -cp "Copy instead of move files"
    echo
}
init ()
{
    Error=0
    SoftwareOnly=0
    Binary=1
    Source=0
    ListFile=CIAO_4.8.2
    TOP="`pwd`"
    RootTree="${TOP}"
    FromTree="${TOP}/${ListFile}_tmp"
    SetFlag=0
    dot="."
    Uninstall=0
    newversion=""
    CP="mv"
    backout=""
    dbg="# "
    ech=""
    cleanup=0
    package=""
    if [ "`uname`" != "Darwin" ] ; then
	SO="so"
    else
	SO="dylib"
    fi

}
move_file ()
{
    if [ "${1}" != "rm" ] ; then
        if [ -f ${2} ] ; then
	    mkdir -p `dirname ${3}`
            if [ -f ${3} ] ; then
                ${ech} rm -f ${3}
            fi
	    ${ech} ${1} ${2} ${3}

	else
	    if [ -d ${2} ] ; then
		if [ -d ${3} ] ; then
		    ${ech} rm -rf ${3}
		fi
		if [ "${1}" != "cp" ] ; then
		    ${ech} ${1} ${2} ${3}
		else
		    mkdir -p "`dirname ${3}`"
		    ${ech} cp -r ${2} ${3}
		fi
	    fi
        fi
    else
	echo remove ${2}
        ${ech} rm -f ${2}
    fi
}

init
while [ "$#" -ne 0 ]
do
    case "${1}"
    in
	-nh )
	    dot=""
	    ;;
        -cp )
	    CP="cp"
	    ;;
	-p )
	    CP="cp"
	    if [ $SetFlag -ne 0 ] ; then
		Error=10
	    fi
	    SetFlag=1
	    SourceOnly=0
	    Binary=1
	    Source=1
	    package="y"
            ;;
	-debug )
	    dbg=""
	    ech="echo"
	    ;;
        -s )
	    if [ $SetFlag -ne 0 ] ; then
		Error=10
	    fi
	    SetFlag=1
	    SoftwareOnly=1
	    Binary=0
	    Source=1
        ;;
	-b )
	    if [ $SetFlag -ne 0 ] ; then
		Error=10
	    fi
	    SetFlag=1
	    SourceOnly=0
	    Binary=1
	    Source=1
	;;
	-f )
	    if [ "${2}" != "" ] ; then
		ListFile="${2}"
		shift
	    else
	        Error=1
	    fi
        ;;
	-r )
	    if [ "${2}" != "" ] ; then
		RootTree="${2}"
		shift
	    else
		Error=2
	    fi
        ;;
	-v )
	    if [ "${2}" != "" ] ; then
		FromTree="${2}"
		shift
	    else
		Error=3
	    fi
        ;;
	-u )
	    if [ "${2}" != "" ] ; then
		Uninstall=1
		newversion="_${2}"
		FromTree="${RootTree}"
		CP="mv"
		backout="${dot}"
		shift
	    else
		Error=4
	    fi
        ;;
	* )
	    Error=1000
	;;
    esac
    shift
done

version_file="${RootTree}/VERSION"
if [ -f ${version_file} ] ; then
    read softname softnum dummy1 < ${version_file}

    oldversion="${softname}_${softnum}"
else
    oldversion="x"
fi

if [ ${Uninstall} -eq 0 ] ; then
    installtest="!="
else
    installtest="="
fi

if [ $Error -eq 0 ] ; then
    if [ ${oldversion} ${installtest} ${ListFile} ] ; then
	cat ${ListFile} |
	while read srcdir bindir srcname binname dummy1
	do
	    donebybin="0"
	    if [ $Binary -eq 1 ] && [ $Source -eq 1 ] && [ "${srcdir}" == "${bindir}" ] && [ "${srcname}" == "${binname}" ] ; then
		donebybin="1"
	    fi
	    if [ $Binary -eq 1 ] ; then
		if [ "${binname}" != "-" ] && [ -f "${FromTree}/${bindir}/${backout}${binname}${newversion}" ] ; then

# Don't backup files in the share/doc/xml directory
# This causes ahelp to generate duplicate entries

		    if [ "${bindir}" != "share/doc/xml" ] ; then
			move_file "mv" "${RootTree}/${bindir}/${binname}" "${RootTree}/${bindir}/${dot}${binname}_${oldversion}"
		    fi
		    move_file "${CP}" "${FromTree}/${bindir}/${backout}${binname}${newversion}" "${RootTree}/${bindir}/${binname}"
		fi
	    fi
	    
	    if [ $Source -eq 1 ] && [ "${donebybin}" == 0 ] ; then
		if [ "${srcname}" != "-" ] && [ -f "${FromTree}/${srcdir}/${backout}${srcname}${newversion}" ] ; then
		    move_file "mv" "${RootTree}/${srcdir}/${srcname}" "${RootTree}/${srcdir}/${dot}${srcname}_${oldversion}"
		    move_file "${CP}" "${FromTree}/${srcdir}/${backout}${srcname}${newversion}" "${RootTree}/${srcdir}/${srcname}"
		fi
	    fi
	done
    else
	if [ "$installtest" = "=" ] ; then
	    echo "Error - Version mismatch - Can't Uninstall"
	else
	    echo "Error - Update was done. Versions match"
	fi
    fi
else
    usage  
fi
